#include <stdio.h>
#include <string.h>
#include <stdbool.h>
#include<unistd.h>
#include "LibTestMain.h"
#include<sys/time.h>
#include <signal.h>
#include <stdlib.h>


/*
bool bIsOpen = false;
void my_handler2(int s)
{
	if(bIsOpen)
	{
		usleep(100000);
		printf("Caught signal %d, call CVR_CloseComm()\n",s);
		CVR_CloseComm();
		usleep(100000);
	}
	exit(0); 
}

int main()
{
	
	struct sigaction sigIntHandler;

	sigIntHandler.sa_handler = my_handler2;
	sigemptyset(&sigIntHandler.sa_mask);
	sigIntHandler.sa_flags = 0;
	
	sigaction(SIGINT, &sigIntHandler, NULL);
	
	//初始化
	//const char *cPath ="/dev/ttyS1";   //100D device path example
	const char *cPath ="/dev/ttyUSB0";  //100A device path example
		
	bool bTerminate = false;
	struct timeval timeStart;
	struct timeval timeEnd; 

	char strTemp[256] = {0x00};
	int strTempLen = sizeof(strTemp);

	while(!bTerminate)	//循环读卡
	{
		usleep(300000);

		int iRet = CVR_InitComm(cPath, 3);
		if(iRet != 1 && iRet != 2)
		{
			printf("CVR_InitComm failed, Ret = %d\n", iRet);
			continue;
		}
		bIsOpen = true;
		
		//读设备状态
		iRet = CVR_GetStatus();
		if(iRet != 1)
		{
			printf("CVR_GetStatus failed, Ret = %d\n", iRet);
			CVR_CloseComm();
			bIsOpen = false;
			continue;
		}

		gettimeofday(&timeStart, NULL);
		
		//卡认证
		iRet = CVR_Authenticate();
		if(iRet != 1)
		{
			//printf("CVR_Authenticate failed, Ret = %d\n", iRet);
			CVR_CloseComm();
			bIsOpen = false;
			continue;
		}


		//读卡
		//iRet = CVR_Read_FPContent(7);
		iRet = CVR_Read_Content(3);
		if(iRet != 1)
		{
			printf("CVR_Read_FPContent failed, Ret = %d\n", iRet);
			CVR_CloseComm();
			bIsOpen = false;
			continue;
		}

		gettimeofday(&timeEnd, NULL);
		int iTime;
		iTime = 1000 * (timeEnd.tv_sec - timeStart.tv_sec) + (timeEnd.tv_usec - timeStart.tv_usec)/1000;
		printf("read card time : %d ms\n", iTime);

		//获取卡类型
		strTempLen = sizeof(strTemp);
		memset(strTemp, 0, strTempLen);
		iRet = GetCertType((unsigned char*)strTemp, &strTempLen);
		if(iRet != 1)
		{
			printf("GetCertType failed, Ret = %d\n", iRet);
			CVR_CloseComm();
			bIsOpen = false;
			continue;
		}
		printf("Card Type:%d\n", strTemp[0]);

		//获取姓名
		strTempLen = sizeof(strTemp);
		memset(strTemp, 0, strTempLen);
		iRet = GetPeopleName(strTemp, &strTempLen);
		if(iRet != 1)
		{
			printf("GetPeopleName failed, Ret = %d\n", iRet);
			CVR_CloseComm();
			bIsOpen = false;
			continue;
		}
		printf("People Name:%s\n", strTemp);

		//获取性别
		strTempLen = sizeof(strTemp);
		memset(strTemp, 0, strTempLen);
		iRet = GetPeopleSex(strTemp, &strTempLen);
		if(iRet != 1)
		{
			printf("GetPeopleSex failed, Ret = %d\n", iRet);
			CVR_CloseComm();
			bIsOpen = false;
			continue;
		}
		printf("People Sex:%s\n", strTemp);
		
		//获取民族/国家地区
		strTempLen = sizeof(strTemp);
		memset(strTemp, 0, strTempLen);
		iRet = GetPeopleNation(strTemp, &strTempLen);
		if(iRet != 1)
		{
			printf("GetPeopleNation failed, Ret = %d\n", iRet);
			CVR_CloseComm();
			bIsOpen = false;
			continue;
		}
		printf("People Nation:%s\n", strTemp);

		//获取头像照片
		unsigned char arrPhotoData[38862];
		int iPhotoDataLen = sizeof(arrPhotoData);
		iRet = GetBMPData(arrPhotoData, &iPhotoDataLen);
		if(iRet != 1)
		{
			printf("GetBMPData failed, Ret = %d\n", iRet);
			CVR_CloseComm();
			bIsOpen = false;
			continue;
		}
		
		FILE* fp_photo = fopen("./LibTestMainPhoto.bmp","wb+");
		if(fp_photo == NULL)
		{
			printf(" write  Photo error\n");
			CVR_CloseComm();
			bIsOpen = false;
			return -1;
		}
		fwrite(arrPhotoData, 1, iPhotoDataLen, fp_photo);
		fclose(fp_photo);

		CVR_CloseComm();
		bIsOpen = false;

	}		
	return 0;
}
*/


//注：如果调用了CVR_InitComm成功打开设备，程序结束前一定要调用CVR_CloseComm()函数，否则下次执行程序将会出错
void my_handler(int s)
{
	usleep(100000);
	printf("Caught signal %d, call CVR_CloseComm()\n",s);
	//CVR_CloseComm();
	int iRet = CVR_CloseComm();
	if(iRet != 1)
	{
		printf("CVR_CloseComm failed, Ret = %d\n", iRet);
	}
	usleep(100000);		//延时100ms 等待系统内部释放资源完成
	exit(0); 
}


//接口测试
int main()
{
	struct sigaction sigIntHandler;

	sigIntHandler.sa_handler = my_handler;
	sigemptyset(&sigIntHandler.sa_mask);
	sigIntHandler.sa_flags = 0;
	
	sigaction(SIGINT, &sigIntHandler, NULL);
	
	
	//初始化
	//const char *cPath ="/dev/ttyS1";   //100D
	const char *cPath ="/dev/ttyUSB0";  //100A
	//const char *cPath ="/dev/ttyAMA1";
	//int iRet = CVR_InitComm(cPath, 1);  //UART
	int iRet = CVR_InitComm(NULL, 2); //USB-OTG
	//int iRet = CVR_InitComm(NULL, 3); //USB-HID
	if(iRet != 1)
	{
		printf("CVR_InitComm failed, Ret = %d\n", iRet);
		return -1;
	}
	
	usleep(1000000);
	
	//读设备状态
	iRet = CVR_GetStatus();
	if(iRet != 1)
	{
		printf("CVR_GetStatus failed, Ret = %d\n", iRet);
		CVR_CloseComm();
		return -1;
	}
	printf("Device Status: OK\n");

	//读安全模块号
	char strTemp[256] = {0x00};
	int strTempLen = sizeof(strTemp);
	iRet = CVR_GetSAMID(strTemp, &strTempLen);
	if(iRet != 1)
	{
		printf("CVR_GetSAMID failed, Ret = %d\n", iRet);
	}
	else
	{	
		printf("SAMID:%s\n", strTemp);
	}
	
	bool bTerminate = false;
	struct timeval timeStart;
	struct timeval timeEnd; 

	while(!bTerminate)	//循环读卡
	{

		usleep(300000);

		gettimeofday(&timeStart, NULL);
		
		//卡认证
		iRet = CVR_Authenticate();
		if(iRet != 1)
		{
			//printf("CVR_Authenticate failed, Ret = %d\n", iRet);
			continue;
		}


		//读卡
		//iRet = CVR_Read_FPContent(7);
		iRet = CVR_Read_Content(3);
		if(iRet != 1)
		{
			printf("CVR_Read_FPContent failed, Ret = %d\n", iRet);
			continue;
		}

		gettimeofday(&timeEnd, NULL);
		int iTime;
		iTime = 1000 * (timeEnd.tv_sec - timeStart.tv_sec) + (timeEnd.tv_usec - timeStart.tv_usec)/1000;
		printf("read card time : %d ms\n", iTime);

		//获取卡类型
		strTempLen = sizeof(strTemp);
		memset(strTemp, 0, strTempLen);
		iRet = GetCertType((unsigned char*)strTemp, &strTempLen);
		if(iRet != 1)
		{
			printf("GetCertType failed, Ret = %d\n", iRet);
			continue;
		}
		printf("Card Type:%d\n", strTemp[0]);

		//获取姓名
		strTempLen = sizeof(strTemp);
		memset(strTemp, 0, strTempLen);
		iRet = GetPeopleName(strTemp, &strTempLen);
		if(iRet != 1)
		{
			printf("GetPeopleName failed, Ret = %d\n", iRet);
			continue;
		}
		printf("People Name:%s\n", strTemp);

		//获取性别
		strTempLen = sizeof(strTemp);
		memset(strTemp, 0, strTempLen);
		iRet = GetPeopleSex(strTemp, &strTempLen);
		if(iRet != 1)
		{
			printf("GetPeopleSex failed, Ret = %d\n", iRet);
			continue;
		}
		printf("People Sex:%s\n", strTemp);
		
		//获取民族/国家地区
		strTempLen = sizeof(strTemp);
		memset(strTemp, 0, strTempLen);
		iRet = GetPeopleNation(strTemp, &strTempLen);
		if(iRet != 1)
		{
			printf("GetPeopleNation failed, Ret = %d\n", iRet);
			continue;
		}
		printf("People Nation:%s\n", strTemp);

		//获取头像照片
		unsigned char arrPhotoData[38862];
		int iPhotoDataLen = sizeof(arrPhotoData);
		iRet = GetBMPData(arrPhotoData, &iPhotoDataLen);
		if(iRet != 1)
		{
			printf("GetBMPData failed, Ret = %d\n", iRet);
			continue;
		}
		
		FILE* fp_photo = fopen("./LibTestMainPhoto.bmp","wb+");
		if(fp_photo == NULL)
		{
			printf(" write  Photo error\n");
			return -1;
		}
		fwrite(arrPhotoData, 1, iPhotoDataLen, fp_photo);
		fclose(fp_photo);

	}		
	iRet = CVR_CloseComm();
	if(iRet != 1)
	{
		printf("CVR_CloseComm failed, Ret = %d\n", iRet);
	}
	return 0;
}

/*
//M1卡接口测试
int main()
{
	const char *cPath ="/dev/ttyUSB0";	//100A
	int iRet = CVR_InitComm(cPath, 1);	//UART
	if(iRet != 1)
	{
		printf("CVR_InitComm failed, Ret = %d\n", iRet);
		return -1;
	}

	//读设备状态
	iRet = CVR_GetStatus();
	if(iRet != 1)
	{
		printf("CVR_GetStatus failed, Ret = %d\n", iRet);
		CVR_CloseComm();
		return -1;
	}
	printf("Device Status: OK\n");

	//找卡选卡
	unsigned int SNR = 0;
	unsigned short TagType = 0;
	iRet = CVR_MF_HL_Request(0, &SNR, &TagType);
	if(iRet != 1)
	{
		printf("CVR_MF_HL_Request failed, Ret = %d\n", iRet);
		CVR_CloseComm();
		return -1;
	}
	printf("SNR = %x\n", SNR);
	printf("TagType = %x\n", TagType);

	//读M1卡
	unsigned char nKey[6] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};
	//unsigned char nKey[6] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	unsigned char ReadBuff[16] = {0X00};
	unsigned int Readlength = sizeof(ReadBuff);
	iRet = CVR_MF_HL_Read(0, SNR, 1, nKey, ReadBuff, &Readlength);
	if(iRet != 1)
	{
		printf("CVR_MF_HL_Read failed, Ret = %d\n", iRet);
		CVR_CloseComm();
		return -1;
	}

	printf("read MF Data:");
	int i;
	for(i = 0; i < Readlength; i++)
	{
		printf("%02x ", ReadBuff[i]);
	}
	printf("\n");

	//写M1卡
	unsigned char WriteBuff[16] = {0X01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f, 0x10};
	unsigned int Writelength = sizeof(WriteBuff);
	iRet = CVR_MF_HL_Write(0, SNR, 1, nKey, WriteBuff, Writelength);
	if(iRet != 1)
	{
		printf("CVR_MF_HL_Write failed, Ret = %d\n", iRet);
		CVR_CloseComm();
		return -1;
	}

	printf("write Data success\n");

	CVR_CloseComm();
	return 0;

}
*/

/*
//金融卡接口测试
int main()
{
	const char *cPath ="/dev/ttyUSB0";	//100A
	int iRet = CVR_InitComm(cPath, 1);	//UART
	if(iRet != 1)
	{
		printf("CVR_InitComm failed, Ret = %d\n", iRet);
		CVR_CloseComm();
		return -1;
	}

	//读设备状态
	iRet = CVR_GetStatus();
	if(iRet != 1)
	{
		printf("CVR_GetStatus failed, Ret = %d\n", iRet);
		CVR_CloseComm();
		return -1;
	}
	printf("Device Status: OK\n");
	
	char FisCardID[64] = {0x00};
	int FisCardIDLen = sizeof(FisCardID);
	char LifeEndData[64] = {0x00};  
	int LifeEndDataLen = sizeof(LifeEndData);
	
	iRet = CVR_M1_MF_GetFisCardID(FisCardID, &FisCardIDLen, LifeEndData, &LifeEndDataLen);
	if(iRet != 1)
	{
		printf("CVR_M1_MF_GetFisCardID failed, Ret = %d\n", iRet);
		CVR_CloseComm();
		return -1;
	}
	
	printf("FisCardID:%s\n", FisCardID);
	printf("LifeEndData:%s\n", LifeEndData);
	
	CVR_CloseComm();
	return 0;
}
*/

/*
//CVR_AnalysisCardInfo接口测试
int main()
{
	
	unsigned char infoBuff1[1295] =
	{0Xaa,0Xaa,0Xaa,0X96,0X69,0X05,0X08,0X00,0X00,0X90,0X01,0X00,0X04,0X00,0X20,0X5f,0Xa2,0X7e,0Xf6,0X53,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,\
	0X20,0X00,0X20,0X00,0X32,0X00,0X30,0X00,0X31,0X00,0X31,0X00,0X39,0X00,0X38,0X00,0X38,0X00,0X31,0X00,0X31,0X00,0X31,0X00,0X38,0X00,0Xb3,0X6c,0X17,0X53,0X01,0X77,0Xaf,0X90,0Xf8,0X90,0X02,0X5e,0X34,0X4e,\
	0X33,0X6f,0Xbf,0X53,0Xf0,0X79,0Xfe,0X52,0X47,0X95,0Xf0,0X79,0Xfe,0X52,0X1c,0X4e,0X51,0X67,0X0d,0X59,0X74,0X51,0Xef,0X8d,0X32,0X00,0X35,0X00,0Xf7,0X53,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,\
	0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X31,0X00,0X33,0X00,0X30,0X00,0X34,0X00,0X32,0X00,0X33,0X00,0X31,0X00,0X39,0X00,0X38,0X00,0X38,0X00,0X31,0X00,0X31,0X00,\
	0X31,0X00,0X38,0X00,0X34,0X00,0X33,0X00,0X32,0X00,0X38,0X00,0X34,0X4e,0X33,0X6f,0Xbf,0X53,0X6c,0X51,0X89,0X5b,0X40,0X5c,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,\
	0X20,0X00,0X32,0X00,0X30,0X00,0X31,0X00,0X31,0X00,0X30,0X00,0X33,0X00,0X33,0X00,0X30,0X00,0X32,0X00,0X30,0X00,0X32,0X00,0X31,0X00,0X30,0X00,0X33,0X00,0X33,0X00,0X30,0X00,0X20,0X00,0X20,0X00,0X20,0X00,\
	0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X20,0X00,0X57,0X4c,0X66,0X00,0X7e,0X00,0X32,0X00,0X00,0Xff,\
	0X85,0X1f,0X51,0X51,0X51,0X3e,0X71,0X0d,0Xd5,0X64,0Xf3,0Xd3,0X83,0Xea,0X72,0X37,0Xa5,0Xba,0X62,0X99,0Xbb,0Xb7,0Xb9,0Xa6,0Xf8,0X6e,0Xb4,0Xe1,0X7e,0X41,0X5d,0X2d,0X09,0X6f,0Xe3,0X1d,0Xd8,0X86,0X16,0Xfa,\
	0X13,0X8f,0Xb6,0Xc8,0Xf1,0Xcf,0X68,0X40,0X4d,0X08,0X53,0X40,0X4f,0X7f,0X4e,0X3b,0X02,0Xa6,0X23,0Xb2,0Xdf,0X04,0Xcf,0Xb0,0X02,0X9e,0X9e,0X32,0X0d,0Xf9,0Xf8,0X34,0X97,0X51,0X8a,0Xa8,0X9f,0X3a,0X5e,0X87,\
	0X43,0X51,0Xae,0Xd4,0X52,0X51,0X51,0X5a,0X3e,0X80,0X27,0X10,0Xd7,0Xce,0Xe3,0X34,0X1a,0X8c,0X88,0Xa8,0X6a,0X43,0X38,0Xd4,0Xd2,0X77,0X9b,0X07,0X66,0Xb3,0X01,0X16,0Xef,0X17,0X6a,0X8f,0X2b,0X3d,0Xa3,0X2c,\
	0Xee,0Xa0,0X5a,0X76,0X8d,0Xdd,0X80,0X85,0X3e,0X45,0Xd6,0Xb4,0X9a,0X09,0X6b,0Xae,0X51,0X33,0Xb4,0X4a,0Xf8,0X09,0X1f,0Xb8,0X92,0Xd9,0X12,0X55,0Xc8,0X11,0Xc9,0X2c,0Xe5,0X79,0X9b,0X1c,0X09,0X46,0X4b,0X84,\
	0Xfa,0X63,0Xd7,0Xa5,0Xca,0X2e,0X94,0Xf2,0X20,0Xcb,0X75,0X06,0Xc8,0X09,0X1d,0Xf5,0X65,0X8a,0X84,0X43,0X17,0Xc3,0X8e,0X8e,0X3b,0X1f,0X61,0Xe2,0Xfa,0Xb6,0X3e,0Xd4,0X50,0Xca,0X13,0Xf5,0Xa8,0X44,0X36,0X17,\
	0X1f,0X26,0X38,0X04,0X8e,0Xb4,0X24,0Xd8,0X5e,0Xdc,0Xfb,0X71,0X5b,0Xd0,0X34,0X94,0Xb7,0X5a,0X2c,0X5d,0X6c,0X16,0Xfb,0X0b,0X5a,0X5c,0X46,0Xc0,0Xcf,0Xdd,0Xd2,0X77,0X9e,0Xcf,0X23,0X74,0X03,0Xab,0X09,0Xd9,\
	0X35,0X71,0X0d,0Xf7,0X6a,0X0d,0X45,0X22,0X2d,0X26,0X61,0X5a,0X30,0Xbd,0X18,0X3f,0Xd7,0Xef,0X77,0Xc4,0X30,0X32,0X6f,0X9d,0Xcf,0X21,0Xb4,0Xb8,0X04,0X22,0X2b,0X08,0X2a,0Xd2,0X12,0X57,0X66,0Xfa,0X44,0X22,\
	0Xb0,0X16,0Xb0,0X9a,0Xcf,0Xf9,0X96,0X13,0X4b,0X30,0X11,0Xfa,0Xcf,0Xbd,0X83,0Xe5,0X1d,0X98,0Xfa,0X57,0Xa7,0Xba,0X64,0X08,0Xb0,0X78,0X7c,0X18,0Xbc,0X7a,0X81,0X89,0X9c,0X03,0X80,0Xce,0Xe1,0Xdc,0X05,0X61,\
	0X06,0X39,0Xc7,0X66,0Xa8,0X62,0X62,0Xf7,0X95,0X26,0X8c,0X5f,0Xcf,0X3e,0Xc2,0X0c,0X97,0Xd3,0X65,0X99,0X85,0X20,0Xd7,0X93,0Xbc,0X2f,0X6a,0X6a,0Xba,0Xab,0Xbc,0X72,0X92,0X75,0X10,0X31,0X24,0X6f,0Xdd,0Xbc,\
	0Xb7,0X32,0X7a,0X07,0Xc7,0X2e,0X91,0X9e,0X45,0Xe6,0X40,0X05,0Xc8,0X50,0Xc1,0X2e,0Xa9,0X76,0X47,0X4e,0X8f,0X23,0X0c,0Xe7,0Xb1,0Xd6,0X1c,0X98,0X9c,0X1a,0X40,0Xb5,0X2a,0Xbd,0X9c,0X9f,0Xb6,0Xea,0Xcc,0Xc7,\
	0X90,0Xae,0X51,0Xec,0X35,0X40,0X20,0X0f,0X43,0Xb5,0X42,0X3b,0Xce,0X71,0X08,0X94,0Xa3,0Xa6,0X20,0X02,0Xce,0Xe4,0Xf8,0X9b,0X2a,0X86,0Xa2,0Xa3,0Xcf,0X31,0Xce,0X4e,0Xf3,0X1f,0X7a,0X85,0X67,0X34,0X07,0Xbf,\
	0Xf7,0Xe7,0Xfb,0X46,0X22,0X7f,0X3f,0Xa8,0X03,0X35,0Xac,0X90,0Xa5,0Xba,0Xf7,0Xd4,0Xaa,0X62,0Xc0,0X38,0Xcf,0Xbc,0X8e,0Xd7,0X56,0X4f,0X0f,0X7b,0X18,0X07,0X0e,0X79,0X17,0X33,0Xd3,0Xf7,0Xc1,0Xbe,0X02,0Xae,\
	0X51,0X0f,0X74,0X98,0Xd6,0Xd5,0X43,0X21,0X80,0Xaa,0Xdb,0X32,0X3e,0X55,0Xdc,0X4e,0X48,0Xdd,0X91,0X31,0X64,0X27,0X66,0Xd3,0X08,0X9e,0X76,0X44,0Xc6,0X99,0X04,0X92,0X6e,0Xff,0Xd3,0Xc2,0Xcc,0Xb9,0Xcd,0X6d,\
	0X51,0Xaa,0X6e,0Xfc,0Xb5,0Xce,0X40,0Xad,0X12,0X46,0X94,0X3f,0X58,0X45,0X44,0X80,0X6a,0X48,0Xb1,0Xb5,0Xc4,0X28,0X5a,0Xb0,0Xf0,0X41,0X13,0X0a,0X24,0X22,0X8b,0Xb8,0X15,0X55,0X05,0Xc7,0X1f,0Xfd,0Xb1,0X73,\
	0X5d,0Xbe,0Xc9,0X42,0X7e,0X46,0X84,0Xcb,0Xe5,0X0d,0Xc3,0X63,0X7c,0Xe9,0Xaa,0X4c,0X99,0Xba,0Xbf,0Xec,0X58,0Xa1,0X48,0X89,0Xa0,0Xc0,0X69,0X05,0X2d,0Xdf,0X36,0X76,0Xc6,0Xab,0Xce,0X58,0Xfd,0X63,0X29,0X13,\
	0Xd5,0Xfe,0X91,0Xef,0X8d,0X35,0X5a,0X12,0X81,0Xe6,0Xbf,0X1c,0X1d,0X98,0Xb4,0X3b,0X61,0X6d,0X17,0X1c,0Xaf,0Xf5,0X84,0Xed,0X4e,0X79,0X86,0X19,0X46,0X20,0X4c,0X74,0X57,0X0b,0X12,0X50,0X7a,0X3b,0Xce,0X26,\
	0Xa6,0Xb3,0Xf1,0Xe5,0X2d,0X6f,0Xba,0X14,0X3e,0Xdf,0Xce,0X24,0X32,0X6b,0X68,0Xa8,0X74,0Xc8,0Xc1,0X87,0Xd8,0X8d,0X4e,0Xab,0Xab,0X96,0Xcf,0Xf7,0X16,0X5f,0Xde,0X7b,0X03,0X86,0X06,0Xfe,0X0d,0Xd0,0X39,0X9e,\
	0X9f,0X0c,0X8f,0Xe8,0X62,0X1b,0X60,0X79,0Xb0,0X5b,0X58,0Xfc,0X07,0Xa3,0X3c,0X90,0Xd0,0X0d,0X20,0X1d,0Xad,0Xd6,0X41,0Xd6,0X03,0X55,0Xe4,0X8d,0X54,0X24,0X47,0X07,0X88,0X89,0X17,0X3a,0X15,0X2f,0X02,0X90,\
	0Xa1,0Xbc,0Xcc,0X7f,0X5b,0Xbe,0Xbe,0X3a,0Xad,0X32,0Xe8,0X7f,0X75,0Xfc,0X0d,0Xe1,0X2f,0Xb5,0X71,0X8b,0X5a,0X1a,0X26,0X2b,0X49,0Xfd,0X8e,0X61,0Xca,0X9c,0X22,0X13,0X42,0X1a,0Xc2,0X37,0Xb8,0Xe3,0X34,0Xcf,\
	0X89,0X56,0Xe3,0X40,0Xb4,0X22,0X85,0X6e,0X57,0Xb6,0X15,0Xba,0X9c,0Xf4,0Xbb,0Xae,0X51,0Xbf,0Xd3,0Xd8,0Xb4,0X15,0Xc6,0X7a,0X5e,0Xd3,0X81,0Xe7,0X0a,0X2e,0X38,0Xc4,0X72,0X4d,0X28,0X69,0X58,0Xdf,0X57,0X66,\
	0X51,0Xc4,0X77,0Xdb,0Xc8,0X64,0Xaa,0X2b,0X28,0Xf8,0X6a,0Xba,0Xa2,0X55,0X75,0X24,0X4a,0X29,0Xaf,0X76,0X42,0Xbc,0Xdd,0X05,0X6c,0Xc8,0X00,0X7f,0Xa7,0X2b,0X58,0X74,0X8d,0X70,0X58,0Xe4,0Xcc,0Xaf,0Xc2,0Xa1,\
	0X3e,0X4f,0Xbf,0Xd8,0Xdf,0X95,0X23,0X85,0Xf7,0X2f,0Xfb,0Xe1,0X72,0Xd3,0Xce,0Xaf,0X79,0X65,0X52,0X5a,0X3e,0X09,0X68,0X7f,0X68,0Xe1,0X4b,0Xea,0X2b,0Xf7,0Xc7,0Xf0,0Xae,0X51,0X85,0Xda,0Xaa,0X89,0X06,0X66,\
	0X68,0Xfc,0X7f,0Xc3,0X0c,0Xa1,0X55,0X81,0X50,0X81,0Xeb,0Xfb,0Xfe,0X95,0Xdd,0X90,0X5e,0Xb8,0X82,0Xa6,0Xb8,0Xd4,0X67,0X51,0X5b,0X44,0Xd8,0X42,0Xf9,0X29,0Xfd,0Xac,0X49,0X20,0X87,0Xb4,0X1b,0Xa0,0X2a,0Xb5,\
	0X7e,0X41,0X53,0X65,0X63,0Xf0,0X0a,0Xf1,0Xf4,0Xee,0X37,0X51,0X0b,0X21,0X05,0X66,0X95,0Xce,0Xe7,0Xa0,0X5a,0X3e,0Xc2,0Xf2,0X00,0X92,0X50,0Xac,0Xe9,0X0f,0X02,0Xef,0Xf6,0X99,0X5c,0X65,0X97,0Xaf,0X1a,0X5d,\
	0X86,0Xb4,0X57,0X4a,0Xf9,0X49,0X81,0Xa5,0Xc9,0X3c,0X5a,0Xbe,0Xbf,0X9e,0Xdb,0X86,0Xc5,0X93,0X62,0X0a,0Xff,0Xeb,0X55,0X81,0X76,0X73,0X99,0Xf5,0Xcf,0X9b,0X8b,0X95,0X7e,0Xcc,0X01,0X64,0Xa6,0X37,0X03,0X5a,\
	0X72,0X67,0Xf2,0X18,0X41,0Xa5,0X8e,0X93,0X76,0X05,0X0b,0X80,0X74,0Xe4,0X52};
	
	
	unsigned char infoBuff2[1295] =
	{0xaa,0xaa,0xaa,0x96,0x69,0x05,0x08,0x00,0x00,0x90,0x01,0x00,0x04,0x00,
	0x10,0x55,0xc7,0x52,0x3a,0x5f,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,
	0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x31,0x00,
	0x30,0x00,0x31,0x00,0x31,0x00,0x39,0x00,0x37,0x00,0x32,0x00,0x31,0x00,0x31,0x00,
	0x31,0x00,0x34,0x00,0x17,0x53,0xac,0x4e,0x02,0x5e,0xa3,0x5b,0x66,0x6b,0x3a,0x53,
	0x2d,0x9e,0x50,0x5b,0x65,0x68,0xef,0x8d,0x39,0x00,0xf7,0x53,0x20,0x00,0x20,0x00,
	0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,
	0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,
	0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x34,0x00,0x35,0x00,0x34,0x00,
	0x33,0x00,0x31,0x00,0x30,0x00,0x31,0x00,0x39,0x00,0x37,0x00,0x32,0x00,0x31,0x00,
	0x31,0x00,0x31,0x00,0x34,0x00,0x39,0x00,0x37,0x00,0x31,0x00,0x58,0x00,0x17,0x53,
	0xac,0x4e,0x02,0x5e,0x6c,0x51,0x89,0x5b,0x40,0x5c,0xa3,0x5b,0x66,0x6b,0x06,0x52,
	0x40,0x5c,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x32,0x00,0x30,0x00,
	0x30,0x00,0x36,0x00,0x31,0x00,0x31,0x00,0x30,0x00,0x32,0x00,0x32,0x00,0x30,0x00,
	0x32,0x00,0x36,0x00,0x31,0x00,0x31,0x00,0x30,0x00,0x31,0x00,0x20,0x00,0x20,0x00,
	0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,
	0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,
	0x57,0x4c,0x66,0x00,0x7e,0x00,0x32,0x00,0x00,0xff,0x85,0x14,0x51,0x51,0x51,0x3e,
	0x71,0x0d,0xd5,0x64,0xf3,0x0f,0x65,0x4d,0x7a,0x66,0xc7,0xe3,0x9d,0x16,0x06,0x65,
	0xe9,0xad,0xc8,0xea,0x8d,0x28,0x02,0x3d,0x21,0x14,0xd4,0xc7,0x67,0x35,0x05,0x60,
	0xb3,0x8c,0xd0,0xfe,0xbd,0x1d,0xce,0xbf,0x43,0x09,0xc2,0x6f,0x9e,0xd9,0x3f,0xe2,
	0xb4,0x75,0x11,0xed,0x80,0xe1,0x36,0xad,0x64,0x41,0x1e,0xa5,0x88,0x67,0x23,0x0e,
	0x4d,0x51,0x51,0xae,0xdf,0x52,0x51,0x51,0x5a,0x3e,0x99,0xae,0x51,0xd6,0x9b,0x96,
	0xd0,0xf1,0x72,0x8b,0x4b,0x9a,0xc5,0x91,0xef,0xee,0xc6,0xd9,0xdf,0xa6,0x1e,0x78,
	0x75,0x9d,0x0e,0x97,0xb0,0x8a,0x8c,0x27,0x90,0xda,0xad,0xd6,0xbe,0xa0,0x18,0x11,
	0xc7,0xa1,0x37,0x4c,0xdf,0x4c,0x15,0x48,0xd7,0x32,0x1f,0x51,0x3d,0x14,0x64,0xfb,
	0xc6,0x21,0xce,0x2b,0x41,0xee,0x52,0xd5,0x6d,0x7b,0xdd,0x82,0xdd,0xc7,0x75,0x04,
	0x6e,0x4e,0xd5,0xf2,0xbd,0x45,0xbe,0x9a,0x19,0xa0,0xa2,0xed,0x13,0xf2,0xa4,0xfe,
	0x13,0x31,0xc8,0xcb,0xe5,0x24,0x51,0x91,0x3d,0x02,0x1e,0x70,0xfb,0x13,0xc3,0xc9,
	0x7e,0x00,0x8c,0xbb,0x85,0x5c,0xef,0x0e,0x40,0x41,0x47,0x56,0xc5,0x00,0xb1,0x6c,
	0x5a,0x71,0x3c,0xc0,0xf9,0x32,0xe1,0x71,0x8e,0xcd,0x68,0xd7,0x0c,0x42,0xa9,0x98,
	0x91,0x2f,0x91,0x9e,0x13,0x07,0x79,0x50,0x77,0xff,0x34,0xd7,0x63,0xbd,0x5f,0xa6,
	0x3d,0x96,0x42,0x3b,0xca,0x7b,0x1c,0x71,0x07,0xe7,0x80,0xa3,0x3e,0x9e,0x68,0xc4,
	0x81,0x7e,0x45,0xfd,0xb4,0x04,0xb0,0xaf,0x08,0x88,0x36,0x7c,0x20,0x93,0x5f,0x81,
	0x80,0xc7,0x5b,0xe2,0x63,0xd7,0x7e,0x4e,0xe6,0x8f,0x57,0x33,0xe0,0x58,0xa2,0x9a,
	0xb4,0xe4,0x88,0x07,0xed,0x22,0x8c,0x1a,0x56,0x5b,0x4c,0xaa,0x52,0xce,0xee,0x25,
	0xb6,0x4b,0x40,0x98,0x1d,0x91,0xa9,0x63,0xe4,0x60,0x66,0xa5,0x60,0x66,0x12,0xf1,
	0xb0,0x97,0x86,0xad,0xb0,0x41,0x4e,0x0b,0xf0,0x8e,0x72,0x09,0xec,0xfe,0x15,0x22,
	0xea,0xac,0xdd,0xf0,0x13,0x55,0x91,0x0a,0x77,0x3d,0x76,0x4b,0x56,0x84,0x6f,0x3d,
	0xf7,0x50,0x37,0x76,0x4e,0x50,0x77,0xf6,0xd9,0x7c,0x80,0x15,0x97,0x02,0xfa,0xf3,
	0x0b,0xc8,0x3a,0x63,0xa4,0x8b,0xf1,0x39,0x72,0xf6,0x84,0x12,0x65,0xfd,0xb6,0x81,
	0xa3,0x76,0x41,0x00,0x55,0xe1,0xf0,0xc6,0x9f,0x1f,0x5e,0xed,0x9e,0x9c,0x88,0x32,
	0xa6,0xd8,0x16,0x6f,0x2f,0x3e,0xfe,0xeb,0x80,0x05,0x51,0x2f,0xa6,0x7f,0x7b,0x3d,
	0x25,0xb9,0x04,0x23,0x11,0xaa,0x6b,0xac,0xc9,0xb9,0x8c,0x6b,0xe1,0x30,0xfa,0x86,
	0x00,0xa3,0xa5,0x8a,0xac,0x30,0xfc,0xbf,0xec,0xda,0xfc,0x19,0x56,0x03,0x77,0xd0,
	0xf7,0x51,0x4e,0x5e,0x57,0xe4,0x7d,0xdd,0xbe,0x16,0xd1,0x40,0xc2,0x3c,0x7e,0x42,
	0x12,0xbf,0xb5,0x9d,0x5e,0xf9,0xe1,0xc0,0xe5,0xf3,0x01,0x25,0xd2,0xbb,0x98,0x63,
	0x42,0xe4,0x9d,0x02,0x46,0xf0,0xc4,0x75,0x3e,0x5b,0xd1,0xaa,0x5f,0x97,0xc5,0xcd,
	0x7c,0xfd,0x6f,0x7b,0x2d,0x81,0x05,0x29,0x2d,0xcc,0xa4,0x8c,0xb2,0x9c,0xc4,0x06,
	0x87,0xb4,0x6a,0x3f,0x5c,0x9e,0xba,0x3f,0x64,0x85,0xd8,0xba,0x15,0xf0,0xcd,0x08,
	0x29,0x3b,0x2c,0x28,0xc6,0x0c,0x57,0xd6,0x0d,0x28,0x12,0x53,0x03,0xc4,0xd8,0xbe,
	0xbc,0x68,0x5f,0xbe,0xbc,0x2b,0x7b,0xdb,0x09,0x17,0xde,0x25,0xe7,0xb4,0x1b,0xe6,
	0x8b,0xde,0x6c,0x4e,0x28,0x57,0x64,0x01,0x4e,0x68,0xe1,0x86,0x9d,0x3e,0x6e,0x6a,
	0xf7,0x8b,0x82,0xae,0x51,0xf7,0xfe,0xd1,0xb6,0x8d,0x56,0x35,0x6f,0xa8,0xa4,0xe8,
	0x40,0x23,0xbc,0x98,0x9a,0x4a,0x79,0x98,0xc4,0xc3,0x21,0xd3,0x61,0x69,0x3b,0x38,
	0x58,0x01,0x43,0xc3,0xf4,0xcb,0x51,0x10,0x0f,0x74,0xe6,0x06,0xe4,0x6e,0xac,0x67,
	0x90,0xb0,0x49,0xdd,0x1e,0x55,0x6e,0x08,0xe1,0xec,0xda,0xfa,0xb8,0x3d,0xda,0x82,
	0x91,0x31,0x9d,0x31,0xe6,0x7a,0x25,0x71,0x87,0x6a,0x29,0x0e,0x44,0x8f,0x22,0x13,
	0x7c,0xd1,0x35,0xae,0x51,0xf6,0x83,0x54,0xcb,0x17,0x77,0x5d,0xcb,0x84,0x4f,0x7d,
	0x55,0x4e,0xdd,0xd6,0x6f,0xf1,0x06,0xce,0xc9,0xe1,0x42,0xbd,0x90,0xc4,0x74,0x11,
	0xf3,0xc9,0xae,0x51,0x14,0x2f,0x16,0xe8,0xc8,0xf2,0xc8,0x90,0x61,0x7e,0x9b,0x8c,
	0x7a,0xfa,0xa5,0xda,0x52,0x62,0x77,0x97,0xae,0x51,0x52,0x58,0x0c,0x5b,0x47,0x08,
	0xe1,0xbb,0xc6,0x80,0x48,0x7a,0x12,0xb3,0x90,0x1b,0x4a,0xba,0xae,0x51,0x5b,0x44,
	0x95,0x06,0x00,0x08,0xf9,0x92,0x91,0xa5,0xc9,0xac,0x7a,0x9a,0xab,0xcf,0xa7,0x2b,
	0x6e,0x79,0x15,0xa9,0x82,0x81,0x37,0x88,0xc0,0xa6,0xd3,0x61,0x5d,0x85,0xdf,0x99,
	0xf2,0x55,0x41,0x74,0x56,0xd1,0xdf,0x46,0x8a,0x67,0x07,0xe6,0xf6,0x57,0xa5,0x86,
	0xad,0xd6,0x3c,0x42,0x0e,0x7c,0x95,0x79,0xdf,0xa7,0x0e,0xf7,0xdc,0xad,0x68,0x79,
	0x75,0x1f,0xed,0x8a,0xac,0x5f,0xb6,0x0e,0xb8,0x4e,0x9d,0x25,0xc6,0x93,0x4a,0xaa,
	0x05,0x91,0x60,0xf7,0x92,0x43,0x06,0x8d,0x23,0x2a,0x8e,0xc6,0x7c,0xf3,0xe4,0xf3,
	0xc7,0x43,0x20,0x5f,0xcc,0x53,0xc2,0x2f,0x63,0x50,0x97,0xc3,0x38,0x6c,0x77,0xa6,
	0x3d,0xb3,0xf9,0xa5,0x46,0x44,0x9e,0xc6,0x09,0x3d,0xd8,0xe3,0xa1,0xc3,0x4d,0xd6,
	0x72,0x3e,0x08,0xb8,0x5a,0x3e,0x0b,0x70,0x95,0x46,0x56,0x4d,0x40,0xaa,0x53,0x37,
	0x6d,0x3d,0xff,0xce,0x9c,0x3f,0xef,0x47,0x9b,0xab,0xe0,0xcb,0x0c,0x4f,0xe1,0x49,
	0x42,0xee,0x33,0x2a,0x06,0x1e,0xaf,0x96,0xd8,0x15,0x98,0x24,0xc0,0x7a,0x55,0xac,
	0x55,0x5a,0x09,0xa9,0x02,0xb1,0x54,0x83,0xdb,0x5c,0x7b,0xf3,0x66,0xb8,0xe0,0xf2,
	0x22,0x50,0xbe,0xb1,0xb2,0xac,0xa1,0xb0,0x5e,0xd2,0x86,0x5d,0x25,0x43,0x5c,0x54,
	0x3c,0x46,0xb3,0x71,0x1e,0xf7,0x5a,0x3e,0x84,0xaa,0xb9,0xbb,0xde,0x52,0xbb,0x40,
	0xb3,0x76,0x54,0x9b,0x07,0x35,0xe9,0x77,0xa8,0x92,0xe2,0x4c,0xda,0x81,0x87,0xd3,
	0xbf,0xc7,0xa0,0x93,0xdc,0x39,0x2c,0x45,0x25,0x52,0xe0,0x9a,0x9c,0x05,0x30,0xd3,
	0x64,0x3a,0x80,0x73,0x5a,0xd1,0x0d,0x59,0x3b,0x3f,0x84,0xbe,0x2f,0x98,0x38,0x64,
	0xf2,0x9e,0x32,0x31,0xe5,0x8e,0xba,0xb3,0x43,0xa9,0x3e,0xdd,0xbb,0x7d,0xf8,0x4b,
	0x00};
	
	
	unsigned char infoBuff3[2321] =
	{0xaa,0xaa,0xaa,0x96,0x69,0x09,0x0a,0x00,0x00,0x90,0x01,0x00,0x04,0x00,0x04,0x00,
	0x96,0x80,0x89,0x8f,0xdc,0x8f,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,
	0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x31,0x00,
	0x30,0x00,0x31,0x00,0x31,0x00,0x39,0x00,0x38,0x00,0x37,0x00,0x31,0x00,0x32,0x00,
	0x32,0x00,0x37,0x00,0x17,0x53,0xac,0x4e,0x02,0x5e,0x1c,0x4e,0xce,0x57,0x3a,0x53,
	0x1c,0x4e,0xa4,0x4e,0x11,0x6c,0xf7,0x5d,0x33,0x00,0x32,0x00,0xf7,0x53,0x0e,0x54,
	0x0f,0x5c,0x62,0x96,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,
	0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,
	0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x33,0x00,0x37,0x00,0x31,0x00,
	0x30,0x00,0x38,0x00,0x32,0x00,0x31,0x00,0x39,0x00,0x38,0x00,0x37,0x00,0x31,0x00,
	0x32,0x00,0x32,0x00,0x37,0x00,0x37,0x00,0x37,0x00,0x31,0x00,0x37,0x00,0x17,0x53,
	0xac,0x4e,0x02,0x5e,0x6c,0x51,0x89,0x5b,0x40,0x5c,0x1c,0x4e,0xce,0x57,0x06,0x52,
	0x40,0x5c,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x32,0x00,0x30,0x00,
	0x31,0x00,0x38,0x00,0x30,0x00,0x32,0x00,0x30,0x00,0x32,0x00,0x32,0x00,0x30,0x00,
	0x33,0x00,0x38,0x00,0x30,0x00,0x32,0x00,0x30,0x00,0x32,0x00,0x20,0x00,0x20,0x00,
	0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,
	0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,0x20,0x00,
	0x57,0x4c,0x66,0x00,0x7e,0x00,0x32,0x00,0x00,0xff,0x85,0x00,0x51,0x51,0x51,0x3e,
	0x71,0x0d,0xd5,0x64,0xf3,0x3a,0x8a,0x60,0x91,0x8e,0x6e,0xa2,0x28,0x23,0x86,0x57,
	0xc9,0xec,0xed,0x39,0xe6,0xd6,0x13,0x37,0xa2,0x80,0x78,0x95,0x55,0xe0,0xb9,0x4b,
	0xcb,0x40,0x90,0xd9,0x53,0x77,0xe2,0x26,0x09,0x95,0xcb,0xb0,0x8e,0xae,0x51,0x4d,
	0xfa,0x4c,0x12,0x39,0x47,0xff,0x1a,0xab,0xb2,0xfd,0xcd,0x8d,0xca,0x64,0x8f,0x96,
	0xec,0x52,0xa6,0x19,0x81,0x42,0xe3,0x1b,0x44,0xa7,0x4e,0xf5,0x70,0xbc,0x11,0xae,
	0xd3,0x52,0x51,0x51,0x5a,0x3e,0x95,0x49,0xb6,0x00,0xd2,0x46,0x8e,0x36,0xaf,0xea,
	0x15,0xc6,0xf7,0x5a,0xc8,0x53,0xae,0x51,0xf3,0xd5,0xe2,0x7c,0x73,0xb6,0x35,0x65,
	0xf1,0xaf,0x2e,0x3f,0xf1,0x61,0x8c,0xed,0x33,0xf3,0x36,0x90,0x45,0xe9,0xb3,0x85,
	0x52,0x01,0x65,0xab,0x00,0x4a,0x0d,0x4f,0x9a,0x02,0x76,0x9c,0xb3,0xeb,0x30,0x57,
	0x74,0x00,0x49,0xfd,0xba,0xf7,0x21,0xc4,0x81,0x82,0x50,0x95,0x19,0x7b,0x88,0xb0,
	0x7e,0x28,0xea,0x0c,0xa3,0xcc,0xe3,0xb2,0xcf,0xf9,0x49,0x30,0xb8,0x7a,0x79,0xb7,
	0xa0,0x61,0x46,0xba,0xac,0xf4,0x62,0x1d,0xc4,0x88,0x75,0xc4,0xbf,0x42,0xf6,0xc0,
	0x1e,0x4c,0x2c,0xce,0xb9,0x21,0xf1,0xe0,0x63,0xca,0x5f,0x4f,0x7e,0xb9,0x0d,0xb6,
	0x48,0xaf,0x65,0x1b,0x6c,0x31,0xba,0xe2,0xcd,0xd0,0x1e,0x77,0x54,0x12,0x66,0xb6,
	0xd2,0x93,0xc3,0xde,0xab,0x99,0xf8,0x97,0x3a,0xd6,0x5f,0x02,0xb4,0x80,0xdd,0xfa,
	0xae,0x51,0xb2,0xcc,0xd5,0xca,0x18,0x8a,0xdb,0x35,0xdd,0x18,0x0a,0x48,0x34,0x59,
	0xe5,0x3d,0x49,0xd5,0xec,0xe0,0xe3,0x64,0xe6,0xb7,0xb6,0x39,0x92,0x2c,0xc4,0x64,
	0xd6,0x34,0x93,0x53,0xb4,0x98,0x17,0x5c,0x64,0x41,0x66,0xcb,0x90,0x24,0x38,0xb6,
	0x15,0x56,0x28,0x57,0x81,0x94,0x4e,0xd0,0xe9,0x27,0xe3,0x03,0xb6,0xdc,0x8d,0xe6,
	0x54,0xb6,0x38,0x27,0x51,0x6c,0x17,0xdb,0x7e,0x74,0xb6,0x1f,0x47,0xe4,0x22,0xe4,
	0xee,0xea,0x0e,0x92,0xc6,0xb6,0x09,0xe4,0xe8,0xf6,0x2e,0x35,0xa6,0x49,0xe2,0xba,
	0x5d,0xc2,0x8a,0x1c,0x94,0x17,0xa9,0x8b,0xdf,0x6d,0x1e,0xa7,0x6b,0x2d,0x3e,0x13,
	0x04,0x57,0x87,0xe6,0x35,0xf7,0x3f,0x85,0x5e,0x76,0x41,0x7d,0x4d,0x36,0xd1,0xb0,
	0xdd,0x90,0xf1,0x87,0x47,0xe2,0xf1,0x53,0xaa,0x60,0x84,0x8b,0xee,0xac,0xc4,0x77,
	0x7f,0x71,0xfc,0x61,0x74,0x14,0xfa,0x0f,0xb6,0x8b,0x8f,0x58,0xa9,0x61,0xcf,0x98,
	0xf4,0x2c,0x09,0x1c,0xa1,0x57,0xd6,0xbe,0x83,0x63,0xeb,0x8c,0x92,0x39,0x4f,0x92,
	0xaf,0x64,0x4b,0x78,0x14,0x02,0xda,0x80,0x64,0x45,0x74,0xb7,0xaa,0x3c,0x2f,0x30,
	0x36,0x3e,0x49,0xe6,0x15,0xe3,0x3f,0xe3,0x1d,0x79,0xb7,0xc8,0xfc,0x5c,0x8b,0x16,
	0x2b,0x74,0xef,0xeb,0xdf,0x14,0x95,0xc2,0x9c,0x0e,0x9d,0xf8,0xf1,0xea,0x51,0x89,
	0x9b,0xb3,0x20,0x8a,0x8e,0x6c,0x75,0x13,0xad,0x05,0x0a,0xed,0xd8,0x64,0x37,0x22,
	0xfa,0x1b,0x5f,0xb7,0x6d,0x04,0xea,0xff,0xfc,0x43,0xa2,0x08,0x17,0xbe,0xfe,0x73,
	0x8f,0xdb,0x4e,0x43,0xc6,0xdc,0xa3,0xae,0x51,0xb9,0x7e,0x84,0xbd,0xf3,0xff,0x4d,
	0x4d,0x71,0x31,0x7c,0x68,0x2c,0x5b,0x25,0xcd,0x61,0x61,0x71,0x27,0x6d,0xac,0xc7,
	0x12,0x83,0xeb,0x4c,0x70,0x07,0xca,0x4f,0x5d,0xcc,0x8f,0xdb,0x6a,0x8b,0x36,0x06,
	0x66,0xa3,0x8d,0xd2,0x69,0x72,0x85,0xc8,0x91,0x90,0xfc,0x8c,0x89,0x27,0xff,0xef,
	0x2d,0x64,0x2b,0x59,0xe5,0x1d,0xef,0xbc,0xbb,0xc5,0x88,0xbb,0xb5,0xef,0x1d,0xfe,
	0x45,0x2a,0x83,0xdc,0xfd,0x8f,0x31,0xb7,0x05,0x24,0x7a,0xe7,0x31,0xc0,0x34,0xd2,
	0x74,0xd3,0xd8,0x9e,0xc5,0x47,0x2c,0x9f,0x5d,0xd5,0x07,0x29,0x29,0x88,0x34,0xed,
	0xa5,0x76,0x5d,0x9a,0x77,0xe0,0x0c,0x4d,0xf9,0x20,0x48,0xdb,0xc1,0xaa,0xd4,0x16,
	0x2d,0x7b,0xe8,0x46,0xb9,0xa2,0xc3,0x5e,0x14,0xc7,0x8a,0xce,0x2d,0x33,0xa4,0xca,
	0x18,0x5e,0x3e,0xc3,0x5c,0xe6,0x1d,0xa7,0xca,0xc4,0xc8,0x4b,0xb6,0x23,0x87,0x61,
	0x60,0xf1,0xf8,0x69,0x7d,0x66,0x6c,0x97,0xfd,0x87,0xc2,0xc5,0xbe,0x22,0xb5,0x60,
	0x9a,0x2e,0x30,0x67,0xb8,0x0e,0xec,0x63,0x97,0x0c,0xd4,0x69,0xdb,0xcd,0x1d,0xdc,
	0xbb,0x7f,0xf3,0xfe,0x0b,0x6b,0x65,0xae,0x51,0x70,0x54,0x32,0x56,0x0b,0x38,0x1c,
	0x01,0x4f,0x0c,0xbe,0xd3,0x02,0x5d,0xba,0x64,0x8f,0x20,0x45,0xfc,0xf7,0x6e,0xfa,
	0xe3,0x16,0xd8,0xb2,0xf7,0x48,0x5d,0xc6,0x1f,0x7e,0x12,0xe5,0x6f,0xc6,0x8b,0xad,
	0x83,0x51,0x78,0xb6,0x44,0x24,0x55,0x1a,0x17,0xef,0xf2,0xa7,0x2d,0x19,0x93,0xc3,
	0x07,0x67,0xae,0x51,0x13,0x89,0x0b,0x33,0x44,0x8c,0xa5,0x29,0xaa,0xe6,0x0c,0x65,
	0xb6,0x3a,0x92,0xaf,0x73,0x83,0xde,0x4d,0x6b,0x4d,0x58,0xfa,0x0e,0x98,0x67,0x59,
	0xf0,0x1d,0x12,0x63,0x42,0x97,0xb5,0x46,0x16,0x8b,0xbc,0xf9,0xfe,0xc9,0x87,0x82,
	0xc9,0x83,0x6b,0x61,0xb6,0xd0,0x76,0x11,0x05,0xd3,0x1b,0xd7,0x92,0x1b,0x5c,0x4d,
	0x5a,0x4e,0xc6,0x81,0x8d,0xf2,0x2c,0x48,0x9c,0x3c,0xfc,0x56,0x7e,0x9e,0x49,0x45,
	0x72,0xbc,0xf2,0xc4,0xb4,0x33,0x1f,0xd5,0x56,0x9a,0xaa,0x1e,0x9c,0x92,0x7b,0xe8,
	0x17,0x95,0x06,0xc2,0xb3,0x5a,0x3e,0xb3,0x24,0xcd,0xb2,0xbf,0x99,0x3e,0x62,0x60,
	0xcd,0x3b,0xb1,0xf1,0x74,0xdc,0x0d,0x7c,0x86,0x7a,0x90,0x27,0x23,0x9a,0x6e,0xa2,
	0x22,0xc0,0x3c,0x7d,0x68,0x11,0x2f,0xb9,0xe4,0x20,0x5f,0x70,0x39,0x9a,0xeb,0xd7,
	0x2a,0x11,0xd4,0x0b,0xcd,0x16,0x66,0x21,0x1c,0x39,0x60,0xcd,0xd4,0x65,0xd9,0xd7,
	0xc7,0x38,0x55,0x37,0xdb,0x52,0x16,0x4e,0xa3,0x3b,0x25,0xc5,0xf5,0x49,0x94,0x12,
	0x30,0xd8,0x03,0xd9,0xac,0x87,0x5a,0x3e,0x0e,0xb2,0xa0,0x1c,0xdd,0x4b,0xba,0x4d,
	0x4a,0xed,0x98,0x54,0xe4,0xaa,0x08,0xd9,0xae,0x51,0xf0,0x9a,0x4e,0x99,0x52,0x66,
	0xa8,0x14,0x38,0x29,0xda,0x3f,0x2f,0x9f,0x9a,0xf4,0xf4,0xe8,0x30,0xfd,0xe8,0xb5,
	0x44,0x40,0x3b,0xef,0x37,0x76,0x65,0xea,0x94,0x49,0x37,0x5b,0xb5,0xec,0x12,0xf3,
	0x4a,0x14,0x86,0x5c,0x33,0xf5,0x1f,0xc3,0x9c,0xb0,0x2d,0x49,0x99,0x75,0x91,0x7d,
	0x43,0x01,0x11,0x12,0x01,0x0b,0x4f,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x2e,0x01,0x9a,0x64,0x0a,0x01,0xff,0xff,0xff,0xff,0xff,0xff,0x32,
	0x0a,0x60,0xfe,0xb7,0x0d,0x43,0xfe,0x74,0x1b,0x9d,0xfc,0xac,0x19,0x98,0xfc,0x27,
	0x1f,0xba,0xfc,0x8e,0x23,0x98,0xfc,0x19,0x34,0x00,0xfc,0x36,0x39,0xae,0xfc,0x47,
	0x4c,0x00,0xfc,0x5a,0x4c,0xac,0xfc,0x2e,0x51,0xb7,0xfc,0x41,0x5c,0xba,0xfc,0xd5,
	0x5d,0x43,0xfe,0x95,0x60,0x99,0xfc,0x25,0x73,0x0e,0xfc,0xdb,0x75,0x8b,0xfc,0x7f,
	0x7d,0x51,0xfe,0x21,0x81,0xc3,0xfc,0x6a,0x85,0xa5,0xfc,0x43,0x89,0x65,0xfe,0xa4,
	0x90,0x95,0xfc,0x32,0xa1,0xc2,0xfc,0x14,0xa3,0x11,0xfc,0xab,0xb4,0x98,0xfc,0x1d,
	0xbd,0xd0,0xfc,0x7a,0xbc,0xa6,0xfc,0x46,0xbf,0xc2,0xfc,0xbe,0xc9,0x3c,0xfe,0x6d,
	0xd2,0xae,0xfc,0x95,0xdb,0x99,0xfc,0xb0,0xdc,0x8b,0xfc,0x46,0xe7,0xd0,0xfc,0x46,
	0x04,0xee,0xfd,0x90,0x03,0x8d,0xfd,0x1a,0x06,0x33,0xfd,0x62,0x11,0xfd,0xfd,0x61,
	0x1c,0x29,0xff,0x37,0x1e,0x07,0xff,0xa3,0x21,0x76,0xfd,0xd6,0x26,0x16,0xff,0xab,
	0x2a,0xfa,0xfd,0x99,0x2d,0x7f,0xfd,0x96,0x34,0x88,0xfd,0xbb,0x42,0xe1,0xfd,0xa3,
	0x50,0x2e,0xfd,0x96,0x5f,0x08,0xfd,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xb9,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x8d,
	0x43,0x01,0x11,0x12,0x01,0x10,0x52,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x33,0x01,0x9a,0x9a,0x0a,0x01,0xff,0xff,0xff,0xff,0xff,0xff,0xaa,
	0x4f,0xbf,0xfc,0x5c,0x5a,0x1c,0xfc,0x38,0x5e,0xdd,0xfc,0x66,0x64,0xd9,0xfc,0x6a,
	0x6a,0x1c,0xfc,0x63,0x86,0xde,0xfc,0x9d,0x8d,0x0b,0xfc,0xbd,0x8c,0x65,0xfe,0x60,
	0x94,0x1f,0xfc,0x6c,0x94,0xde,0xfc,0x8b,0x96,0xcf,0xfc,0x77,0x9d,0x14,0xfc,0x5d,
	0xa7,0x27,0xfc,0xe1,0xa8,0xa5,0xfc,0x8e,0xac,0x11,0xfc,0x4f,0xbd,0x26,0xfc,0x96,
	0xbd,0x0e,0xfc,0xc7,0xbb,0x54,0xfe,0xc8,0xc2,0xa9,0xfc,0xae,0xca,0x60,0xfe,0x66,
	0xd9,0x1e,0xfc,0x95,0xdb,0x06,0xfc,0xba,0xe0,0x51,0xfe,0x72,0xe9,0x18,0xfc,0xb0,
	0xf1,0x4c,0xfe,0xef,0xf8,0x86,0xfc,0xa2,0xfd,0x45,0xfe,0xc2,0x00,0x30,0xff,0x14,
	0x03,0xfa,0xfd,0x62,0x0b,0x2e,0xfd,0xa9,0x14,0x15,0xff,0x9c,0x15,0xf6,0xfd,0x96,
	0x18,0xe0,0xfd,0x65,0x22,0x29,0xfd,0x26,0x28,0x19,0xff,0x48,0x27,0x43,0xfd,0xd2,
	0x27,0x0e,0xff,0x91,0x2b,0xdb,0xfd,0x53,0x31,0x14,0xfd,0x70,0x32,0x22,0xfd,0xb9,
	0x32,0xf3,0xfd,0x45,0x33,0x5a,0xff,0x5d,0x39,0xb4,0xfd,0x24,0x3d,0x68,0xfd,0x1f,
	0x45,0x38,0xff,0x9b,0x47,0xde,0xfd,0x30,0x4b,0x54,0xff,0x5a,0x4c,0xb4,0xfd,0x1f,
	0x55,0x7a,0xfd,0x58,0x57,0xb7,0xfd,0x1d,0x59,0x51,0xff,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc1,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1f,
	0x00};
	
	//int iRet = CVR_AnalysisCardInfo(infoBuff1, 1295);
	//int iRet = CVR_AnalysisCardInfo(infoBuff2, 1295);
	int iRet = CVR_AnalysisCardInfo(infoBuff3, 2321);
	if(iRet != 1)
	{
		printf("CVR_AnalysisCardInfo, Ret = %d\n", iRet);
		return -1;
	}

	char strTemp[256] = {0x00};
	int strTempLen = sizeof(strTemp);
	
	//获取卡类型
	strTempLen = sizeof(strTemp);
	memset(strTemp, 0, strTempLen);
	iRet = GetCertType((unsigned char*)strTemp, &strTempLen);
	if(iRet != 1)
	{
		printf("GetCertType failed, Ret = %d\n", iRet);
		return -1;
		
	}
	printf("Card Type:%d\n", strTemp[0]);

	//获取姓名
	strTempLen = sizeof(strTemp);
	memset(strTemp, 0, strTempLen);
	iRet = GetPeopleName(strTemp, &strTempLen);
	if(iRet != 1)
	{
		printf("GetPeopleName failed, Ret = %d\n", iRet);
		return -1;
	}
	printf("People Name:%s\n", strTemp);

	//获取性别
	strTempLen = sizeof(strTemp);
	memset(strTemp, 0, strTempLen);
	iRet = GetPeopleSex(strTemp, &strTempLen);
	if(iRet != 1)
	{
		printf("GetPeopleSex failed, Ret = %d\n", iRet);
		return -1;
	}
	printf("People Sex:%s\n", strTemp);
	
	//获取民族/国家地区
	strTempLen = sizeof(strTemp);
	memset(strTemp, 0, strTempLen);
	iRet = GetPeopleNation(strTemp, &strTempLen);
	if(iRet != 1)
	{
		printf("GetPeopleNation failed, Ret = %d\n", iRet);
		return -1;
	}
	printf("People Nation:%s\n", strTemp);

	//获取头像照片
	unsigned char arrPhotoData[38862];
	int iPhotoDataLen = sizeof(arrPhotoData);
	iRet = GetBMPData(arrPhotoData, &iPhotoDataLen);
	if(iRet != 1)
	{
		printf("GetBMPData failed, Ret = %d\n", iRet);
		return -1;
	}
	
	FILE* fp_photo = fopen("./LibTestMainPhoto.bmp","wb+");
	if(fp_photo == NULL)
	{
		printf(" write  Photo error\n");
		return -1;
	}
	fwrite(arrPhotoData, 1, iPhotoDataLen, fp_photo);
	fclose(fp_photo);

	return 0;
}
*/
